// ビットマップ(BMP)ファイルの描画サンプル
//  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <skST7735x_img.h>

// IC=ST7735R 1.8インチ 18ビットカラー 128x160ドット (緑シール)
skST7735x_img IMG=skST7735x_img(CHIP_ST7735X | DISPLAY_TYPE_1) ;

void setup()
{
     int ans ;

     Serial.begin(9600) ;

     // ディスプレイモジュールの初期化を行う
     IMG.begin(BLACK_SCREEN) ;
     // イメージ出力関連の初期化を行う
     ans = IMG.imgInit(4) ;   // SDカードのセレクトピンは"D4"
     if (ans != 0) {
          Serial.println("imgInit Failure!") ;
          while(1) ;          // 終了(カードの初期化に失敗したか、又はＳＤが入っていない)
     }
     Serial.println("imgInit success!") ;

     // BMPファイルをＳＤから読み出して描画を行う
     ans = IMG.PutImage(0,0,"EBINE.BMP") ;
     if (ans == 1) Serial.println("File open error!") ;
     if (ans == 2) Serial.println("No BMP file! or No 24Color!") ;
}
void loop()
{
 
     delay(1000) ;
}

