// ビットマップ(BMP)ファイルと漢字文字の描画サンプル
//  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <skST7735x_img.h>

// IC=ST7735R 1.8インチ 18ビットカラー 128x160ドット (緑シール)
skST7735x_img IMG=skST7735x_img(CHIP_ST7735X | DISPLAY_TYPE_1) ;

// 漢字データを"JISコード"で設定する、最後はNULLを入れる
uint16_t kanji_dt[]={0x242C,0x2473,0x2450,0x246C,0x3727,0x4B5C,0} ;   // "がんばれ熊本"

void setup()
{
     int ans ;

     Serial.begin(9600) ;

     // ディスプレイモジュールの初期化を行う
     IMG.begin(WHITE_SCREEN) ;
     // イメージ出力関連の初期化を行う
     ans = IMG.imgInit(4) ;   // SDカードのセレクトピンは"D4"
     if (ans != 0) {
          Serial.println("imgInit Failure!") ;
          while(1) ;          // 終了(カードの初期化に失敗したか、又はＳＤが入っていない)
     }
     Serial.println("imgInit success!") ;

     // BMPファイルをＳＤから読み出して描画を行う
     ans = IMG.PutImage(30,10,"KUMAMON.BMP") ;
     if (ans == 1) Serial.println("File open error!") ;
     if (ans == 2) Serial.println("No BMP file! or No 24Color!") ;
     // 漢字を赤色で表示する
     IMG.ColorSet(63,0,0) ;
     IMG.PutsK(35,110,(uint16_t *)kanji_dt) ;

}
void loop()
{
 
     delay(1000) ;
}

