// １０キーデータの入力を行うサンプル
//  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <skST7735x_10key.h>

// IC=ST7735R 1.8インチ 18ビットカラー 128x160ドット (緑シール)
skST7735x_10key INP=skST7735x_10key(CHIP_ST7735X | DISPLAY_TYPE_1) ;

uint8_t prc_f ;
uint8_t MojiBuf[8] ;

void setup()
{
     Serial.begin(9600) ;

     // ディスプレイモジュールの初期化を行う
     INP.begin(BLACK_SCREEN) ;

     prc_f = 0 ;
     // 10キー入力ツールを表示させる
     INP.num10KeyON(50,30) ;

}
void loop()
{
     int ans ;

     if (prc_f == 0) {
          // 1回入力処理させたら終了
          ans = INP.num10KeyIn(5,MojiBuf) ;
          if (ans == 1) {
               prc_f = 1 ;
               INP.ColorSet(63,63,0) ;
               INP.Puts(0,0,MojiBuf) ;
               printHex(MojiBuf,8) ;
          }
     }
}
// メモリのＨＥＸダンプ表示
void printByte(uint8_t value) {
  Serial.print(value >> 4, HEX);
  Serial.print(value & 0xF, HEX);
}
void printHex(uint8_t* p, uint32_t len) {
  int i = 0;
  while (i < len) {
    if ((i & 0xf) == 0) {
      Serial.print(F("\n"));
      printByte(i >> 4);
      Serial.print(F(": "));
    }
    printByte(*p++);
    i++;
  }
  Serial.print(F("\n"));
}

