/*******************************************************************************
*  skST7735x - ST7735`bvTFT-LCDp֐Cũwb_t@C           *
*              ST7735R/S`bv(ΐF^u)̂݊mF                     *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2019-04-22  ޒH[     Create                                 *
* ============================================================================ *
*   Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                             *
*******************************************************************************/
#ifndef _SKST7735X_H_
#define _SKST7735X_H_

#include "arduino.h"

/*******************************************************************************
*	萔̒`                                                                *
*******************************************************************************/
// `bvƃfBXvC̏
#define CHIP_ST7735X       0x01    // Rg[-hb`bv ST7735R/S
#define DISPLAY_TYPE_1     0x10    // 1.8C` 18rbgJ[ 128x160hbg(ΐF^u)

#define DISPLAY_COLUMN128   128    // fBXvC̗128hbg
#define DISPLAY_ROW160      160    // fBXvC̍s160hbg
#define DISPLAY_COLUMN132   132    // fBXvC̗132hbg
#define DISPLAY_ROW162      162    // fBXvC̍s162hbg

// SPIs̐ݒ(̑"UNO"dl)
#define TFT_DC                8    // SPIf[^̃p[^̓R}hIs
#define TFT_CS               10    // TFT_LCDW[Is

// R}hƃp[^̏
#define ST7735X_COMMAND       0    // SOĨf[^̓R}hw
#define ST7735X_PARAMETER     1    // SOĨf[^̓p[^w

#define ST7735X_CMD_SWREST    0x01 // \tgEFAZbg
#define ST7735X_CMD_SLPIN     0x10 // X[v
#define ST7735X_CMD_SLPOUT    0x11 // X[v̕A
#define ST7735X_CMD_INVOFF    0x20 // ]\nee
#define ST7735X_CMD_INVON     0x21 // ]\nm
#define ST7735X_CMD_DISPOFF   0x28 // fBXvCnee
#define ST7735X_CMD_DISPON    0x29 // fBXvCnm
#define ST7735X_CMD_CASET     0x2A // AhX̐ݒ
#define ST7735X_CMD_RASET     0x2B // sAhX̐ݒ
#define ST7735X_CMD_RAMWR     0x2C // ɏ
#define ST7735X_CMD_MADCTL    0x36 // 
#define ST7735X_CMD_COLMOD    0x3A // F̊Kw肷

#define ST7735X_PARA_12COLOR  3    // 12rbgJ[(R:4 G:4 B:4)w肷
#define ST7735X_PARA_16COLOR  5    // 16rbgJ[(R:5 G:6 B:5)w肷
#define ST7735X_PARA_18COLOR  6    // 18rbgJ[(R:6 G:6 B:6)w肷

#define BLACK_SCREEN          0
#define WHITE_SCREEN          1


// ֐̃vg^Cv錾
/*******************************************************************************
*	NX̒`                                                              *
*******************************************************************************/
class skST7735x
{
  protected :
     uint8_t  DSP_Info ;
     uint16_t X_Start ;
     uint16_t X_End   ;
     uint16_t Y_Start ;
     uint16_t Y_End   ;
     uint8_t  ColorInfo ;
     uint8_t  RGB[3] ;

     void DisplayInit() ;
     void SendByte(uint8_t value, uint8_t dc) ;
     void SendWord(uint16_t value) ;
     uint8_t RangSET(uint16_t xs, uint16_t xe, uint16_t ys, uint16_t ye) ;

  public:
          skST7735x(uint8_t dspinfo) ;
     void begin(uint8_t value) ;
     void DisplayDirection(uint8_t value) ;
     void CLS(uint8_t value) ;
     void ColorSet(uint8_t red, uint8_t green, uint8_t blue) ;
     void ReduceColorSet(uint8_t red, uint8_t green, uint8_t blue) ;
     void PutPixel(uint16_t xp, uint16_t yp) ;
     void Circle(uint16_t xp, uint16_t yp, uint16_t radius) ;
     void FillCircle(uint16_t xp, uint16_t yp, uint16_t radius) ;
     void Line(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void Box(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void FillBox(uint16_t xsp, uint16_t ysp, uint16_t xep, uint16_t yep) ;
     void Putc(uint16_t xp, uint16_t yp, uint8_t c) ;
     void Puts(uint16_t xp, uint16_t yp, uint8_t *s) ;
     void Putc2x(uint16_t xp, uint16_t yp, uint8_t c) ;
     void Puts2x(uint16_t xp, uint16_t yp, uint8_t *s) ;
     void SleepCtl(uint8_t sel) ;
     void DisplayINV(uint8_t sel) ;
} ;

#endif
